/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: excalibur.c,v 1.5 2003/12/24 08:00:42 honda Exp $
 */

/*
 *    Excalibur-ARM ǽѥɥ饤
 */
#include <s_services.h>
#include <excalibur.h>

/*
 * UART ʰSIOɥ饤
 */

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block {

} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block {
    const SIOPINIB  *siopinib; /* ꥢI/OݡȽ֥å */
    VP_INT          exinf;     /* ĥ */
    BOOL    openflag;          /* ץѤߥե饰 */
    BOOL    sendflag;          /* ߥ֥͡ե饰 */
    BOOL    getready;          /* ʸ */
    BOOL    putready;          /* ʸǤ */
};

/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {{}};

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB  siopcb_table[TNUM_SIOP];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)  ((UINT)((siopid) - 1))
#define get_siopcb(siopid)  (&(siopcb_table[INDEX_SIOP(siopid)]))


/*
 * ʸ?
 */ 
Inline BOOL
uart_getready(SIOPCB *siopcb)
{
    return((sil_rew_mem((VP)UART_RSR) & UART_RSR_RX_LEVEL) > 0x00);
}

/*
 * ʸǤ뤫?
 */
Inline BOOL
uart_putready(SIOPCB *siopcb)
{
  return((sil_rew_mem((VP)UART_TSR) & UART_TSR_TX_LEVEL) < UART_TX_FIFO_MAX);
}

/*
 *  ʸμФ
 */
Inline UB
uart_getchar(SIOPCB *siopcb)
{
    return((UB)sil_rew_mem((VP)UART_RD));  
}

/*
 *  ʸν񤭹
 */
Inline void
uart_putchar(SIOPCB *siopcb, UB c)
{
    sil_wrw_mem((VP)UART_TD, (VW)c);
}

/*
 *  ߵ
 */
Inline void
uart_enable_send(SIOPCB *siopcb)
{
    sil_wrw_mem((VP)UART_IES,(VW)UART_INT_T);
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_send(SIOPCB *siopcb)
{
    sil_wrw_mem((VP)UART_IEC,(VW)UART_INT_T);
}

/*
 *  ߵ
 */
Inline void
uart_enable_rcv(SIOPCB *siopcb)
{
    sil_wrw_mem((VP)UART_IES,(VW)UART_INT_R);
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_rcv(SIOPCB *siopcb)
{
    sil_wrw_mem((VP)UART_IEC,(VW)UART_INT_R);
}



/*
 * ͥ뵯ưΥѤν
 */
void
uart_init(void){
    /* Data 8bit, 1 stop bit, No parity */
    sil_wrw_mem((VP)UART_MC,(VW)UART_DATA_FOMAT);
    
    /* Set bound rate */
    sil_wrw_mem((VP)UART_DIV_LO,(VW)(CAL_BPS(UART_BPS,AHB1_CLK/2) & 0xff));
    sil_wrw_mem((VP)UART_DIV_HI,
                (VW)(CAL_BPS(UART_BPS,AHB1_CLK/2) & 0xff00) >> 8);

    /* clear FIFO  TxThr = 0 RxThr = 1*/
    sil_wrw_mem((VP)UART_FCR,(VW)(UART_FCR_TC | UART_FCR_RC));
  
    /* Clear interrupt */
    sil_wrw_mem((VP)UART_IEC,
                (VW)(UART_INT_R | UART_INT_T | UART_INT_TI | UART_INT_M));
}


/*
 *  åפUARTΥݡ󥰽
 */
void
uart_putc(char c)
{
    UW buf_level;
    
    do{
        buf_level = sil_rew_mem((VP)UART_TSR) & UART_TSR_TX_LEVEL;
    }while(buf_level >= UART_TX_FIFO_MAX);
    
    sil_wrw_mem((VP)UART_TD,(VW)c);
}

/*
 *  SIOɥ饤Фν롼
 *  1ݡȤʤᡤޤ̣Ϥʤ
 */
void
uart_initialize()
{
    SIOPCB  *siopcb;
    UINT    i;

    /*
     *  ꥢI/Oݡȴ֥åν
     */
    for (siopcb = siopcb_table, i = 0; i < TNUM_SIOP; siopcb++, i++) {
        siopcb->siopinib = &(siopinib_table[i]);
        siopcb->openflag = FALSE;
        siopcb->sendflag = FALSE;
    }
}

/*
 * ץ󤷤ƤݡȤ뤫
 */
BOOL
uart_openflag(void)
{
    return(siopcb_table[0].openflag);
}


/*
 * ꥢI/OݡȤΥץ
 */
SIOPCB *
uart_opn_por(ID siopid, VP_INT exinf)
{
    SIOPCB      *siopcb;
    const SIOPINIB  *siopinib;

    siopcb = get_siopcb(siopid);
    siopinib = siopcb->siopinib;

    uart_init();
    
    /* Data 8bit, 1 stop bit, No parity */
    sil_wrw_mem((VP)UART_MC,(VW)UART_DATA_FOMAT);
    
    /* Set bound rate */
    sil_wrw_mem((VP)UART_DIV_LO,(VW)(CAL_BPS(UART_BPS,AHB1_CLK/2) & 0xff));
    sil_wrw_mem((VP)UART_DIV_HI,
                (VW)(CAL_BPS(UART_BPS,AHB1_CLK/2) & 0xff00) >> 8);

    /* clear FIFO  TxThr = 0 RxThr = 1*/
    sil_wrw_mem((VP)UART_FCR,(VW)(UART_FCR_TC | UART_FCR_RC));
  
    /* Clear interrupt */
    sil_wrw_mem((VP)UART_IEC,
                (VW)(UART_INT_R | UART_INT_T | UART_INT_TI | UART_INT_M));

    /* ߵ */
    sil_wrw_mem((VP)UART_IES,(VW)UART_INT_R);
    
    siopcb->exinf = exinf;
    siopcb->getready = siopcb->putready = FALSE;
    siopcb->openflag = TRUE;

    return(siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
uart_cls_por(SIOPCB *siopcb)
{
    siopcb->openflag = FALSE;
}

/*
 *  ꥢI/OݡȤؤʸ
 */
BOOL
uart_snd_chr(SIOPCB *siopcb, char c)
{
    if (uart_putready(siopcb)){
        uart_putchar(siopcb, c);
        return(TRUE);
    }
    return(FALSE);
}

/*
 *  ꥢI/OݡȤʸ
 */
INT
uart_rcv_chr(SIOPCB *siopcb)
{
    if (uart_getready(siopcb)) {
        return((INT)(UB) uart_getchar(siopcb));
    }
    return(-1);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
uart_ena_cbr(SIOPCB *siopcb, UINT cbrtn)
{
    switch (cbrtn) {
        case SIO_ERDY_SND:
            uart_enable_send(siopcb);
            break;
        case SIO_ERDY_RCV:
            uart_enable_rcv(siopcb);
            break;
    }
}


/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
uart_dis_cbr(SIOPCB *siopcb, UINT cbrtn)
{
    switch (cbrtn) {
        case SIO_ERDY_SND:
            uart_disable_send(siopcb);
            break;
        case SIO_ERDY_RCV:
            uart_disable_rcv(siopcb);
            break;
    }
}



/*
 *  ꥢI/OݡȤФ߽
 */
static void
uart_isr_siop(SIOPCB *siopcb)
{
    if (uart_getready(siopcb)) {
        /*
         *  ΥХå롼ƤӽФ
         */
        uart_ierdy_rcv(siopcb->exinf);
    }
    if (uart_putready(siopcb)) {
        /*
         *  ǽХå롼ƤӽФ
         */
        uart_ierdy_snd(siopcb->exinf);
    }
}


/*
 *  SIOγߥӥ롼
 */
void
uart_isr()
{
    uart_isr_siop(&(siopcb_table[0]));
}

