/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_timer.h,v 1.6 2003/12/11 00:44:27 honda Exp $
 */

/*
 *  ޥ⥸塼 Excalibur-ARMѡ
 *  TIMER0
 */

#ifndef _HW_TIMER_H_
#define _HW_TIMER_H_

#include <s_services.h>
#include <excalibur.h>

/*
 *  ޳ߤγֹ(ޡ˥åȤͥ)
 */
#define    INHNO_TIMER    INTLV_TIM0

#ifndef _MACRO_ONLY

/*
 *  ͤɽη
 */
typedef UW    CLOCK;

/*
 *  ͤɽȥߥáñ̤ȤѴ
 *  TIMER_CLOCK ϥåȥܡ
 */
#define TO_CLOCK(nume, deno)    (TIMER_CLOCK * (nume) / (deno))
#define TO_USEC(clock)      ((clock) * 1000 / TIMER_CLOCK)

/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK    ((CLOCK) 0xffffffff)

/*
 *  ޤθͤȯͤȤߤʤȽ
 */
#define GET_TOLERANCE    100
#define BEFORE_IREQ(clock) \
        ((clock) >= TO_CLOCK(TIC_NUME, TIC_DENO) - GET_TOLERANCE)

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
Inline void
hw_timer_initialize()
{
    CLOCK    cyc = TO_CLOCK(TIC_NUME, TIC_DENO);
        
    sil_wrw_mem((VP)TIMER0_CR,0x00);  /* ,ߥꥢ,߶ػ */
    assert(cyc <= MAX_CLOCK);         /* ޾ͤΥå */
    sil_wrw_mem((VP)TIMER0_READ,0x00);/* ͥꥢ       */
    
    /*
     * ʲʬνɲä롥
     */
    sil_wrw_mem((VP)TIMER0_LIMIT,cyc); /* ͥå                 */
    sil_wrw_mem((VP)TIMER0_PRE,0x00);         
    
    /*
     *  ߴϢ
     */
    /* ߥ٥(եȥ) */
    define_inh_mask(INHNO_TIMER,INT_MASK_T0);
    
    /* ߥ٥(INT) */
    /* ͥ             */
    sil_wrw_mem((VP)INT_PRIORITY_TIMER0,INTLV_TIM0);
    /* ߥޥꥢߵ */
    sil_wrw_mem((VP)INT_MASK_SET,INT_MASK_T0);
    
    /* ߵ,ޥ */
    sil_wrw_mem((VP)TIMER0_CR,(TIMER0_CR_IE | TIMER0_CR_S)); 
}



/*
 *  ޳׵Υꥢ
 */
Inline void
hw_timer_int_clear()
{
    sil_wrw_mem((VP)TIMER0_CR, sil_rew_mem((VP)TIMER0_SR));
}


/*
 *  ޤ߽
 */
Inline void
hw_timer_terminate()
{
    /* ,ߥꥢ,߶ػ */
    sil_wrw_mem((VP)TIMER0_CR,0x00);
    /* ߥޥåȳ߶ػ */
    sil_wrw_mem((VP)INT_MASK_SET,INT_MASK_T0);
}


/*
 *  ޤθͤɤߤ
 *
 *  ߶ػ߶ǸƤӽФȡ
 */
Inline CLOCK
hw_timer_get_current(void)
{
    return(TO_CLOCK(TIC_NUME, TIC_DENO) -
           sil_rew_mem((VP)TIMER0_READ));
}


Inline BOOL
hw_timer_fetch_interrupt(void)
{
    return(sil_rew_mem((VP)INT_SOURCE_STATUS) & INT_MASK_T0);
}

#endif /* _MACRO_ONLY */
#endif /* _HW_TIMER_H_ */
