/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sys_config.c,v 1.6 2003/12/11 00:44:27 honda Exp $
 */

/*
 *    åȥƥ¸⥸塼Excalibur-ARMѡ
 */

#include "jsp_kernel.h"
#include <excalibur.h>



/*
 * ߥϥɥϿѥơ֥
 */
FP   int_table[MAX_INT_NUM];
UW   int_mask_table[MAX_INT_NUM];

/*
 *  åȥƥ¸ν
 */
void
sys_initialize()
{
    int i;
  
    /*
     *  ߥơ֥ν
     */
    for(i = 0; i < MAX_INT_NUM; i++){
        int_table[i] = 0x00;        /* ꥻå */
        int_mask_table[i] = 0x1ffff;   /* ߶ػ */
    }

    /*
     *  ARMΥ٥ơ֥سߥϥɥϿ
     */
    arm_install_handler(IRQ_Number,IRQ_Handler);
  
    /*
     *  ߥȥν
     */
    sil_wrw_mem((VP)INT_MASK_CLEAR,0x1ffff);     /* Ƥγߤػ */
    sil_wrw_mem((VP)INT_MODE,INT_MODE_SII);      /* ߥ⡼ɤ */
 
    /*
     *  sys_putc ǽˤʤ褦UART
     */
    uart_init();
}


/*
 *  åȥƥνλ
 */
void
sys_exit(void)
{
#ifdef GDB_STUB
    stub_exit();
#else  /* WITH_OUT_GDB_STUB */
    syslog(LOG_EMERG, "End Kernel.....!");
    while(1);
#endif /* GDB_STUB */  
}




/*
 *  åȥƥʸ
 */
void
sys_putc(char c)
{
#ifdef GDB_STUB  
    if (c == '\n') {
        stub_putc('\r');
    }
    stub_putc(c);
#else
    if (c == '\n') {
        uart_putc('\r');
    }
  uart_putc(c);  
#endif /* GDB_STUB */  
}


/*
 *  ߥϥɥ
 *
 *  ֹ inhno γߥϥɥεưϤ inthdr ꤹ롥
 */
void
define_inh(INHNO inhno, FP inthdr)
{
    assert(inhno < MAX_INT_NUM);
    int_table[inhno] = inthdr;
#ifdef GDB_STUB  
    /*  
     * GDB StubϿơȯ˸ƤФ褦ˤ롥
     */
    stub_set_inh(inhno,IRQ_Handler);
#endif /* GDB_STUB */  
}


/*
 * ߥϥɥ鵯ư˳ߥȥ顼˥åȤޥͤꡥ
 */
void
define_inh_mask(INHNO inhno, UW mask)
{
    assert(inhno < MAX_INT_NUM);
    int_mask_table[inhno] = mask;
}


/*
 *  ̤γߤäν
 */
void
undef_interrupt(){
    syslog(LOG_EMERG, "Unregistered Interrupt occurs.");
    while(1);
}
