/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sys_support.S,v 1.6 2003/12/11 00:44:27 honda Exp $
 */

#define _MACRO_ONLY
#include "jsp_kernel.h"
#include <excalibur.h>
        




/*
 *  ٥Υåȥƥ¸ν
 *
 *  ȥåץ⥸塼ǡ˸ƤӽФ롥          
 */       

        .text
        .align 2
        .global hardware_init_hook
hardware_init_hook: 

#ifdef EXCALIBUR_PLL_INIT
/*
 * Excalibur ¸ν. 
 */
        /*    
         *  PLLν
         */    
        /* Set N            */
        ldr     r0,=CLK_PLL1_NCNT
        ldr     r1,=CLK_PLL1_NCNT_VAL
        str     r1,[r0]
        
        ldr     r0,=CLK_PLL2_NCNT
        ldr     r1,=CLK_PLL2_NCNT_VAL
        str     r1,[r0]
        
        /* Set M            */
        ldr     r0,=CLK_PLL1_MCNT
        ldr     r1,=CLK_PLL1_MCNT_VAL
        str     r1,[r0]

        ldr     r0,=CLK_PLL2_MCNT
        ldr     r1,=CLK_PLL2_MCNT_VAL
        str     r1,[r0]        

        /* Set K            */
        ldr     r0,=CLK_PLL1_KCNT
        ldr     r1,=CLK_PLL1_KCNT_VAL
        str     r1,[r0]

        ldr     r0,=CLK_PLL2_KCNT
        ldr     r1,=CLK_PLL2_KCNT_VAL
        str     r1,[r0]                        

        
        /* Start PLL1       */
        ldr     r0,=CLK_PLL1_CTRL
        ldr     r1,=CLK_PLL1_CTRL_VAL
        str     r1,[r0]
        
        ldr     r0,=CLK_PLL2_CTRL
        str     r1,[r0]
        
    
        /* Clear PLL1 and PLL2 bypass bit */    
        ldr     r0,=CLK_DERIVE
//        ldr     r1,=0x2010
        ldr     r1,=0x10
        str     r1,[r0]        

        /* Wait PLL to lock     */
        ldr     r0,=CLK_STATUS
1:
        ldr     r1,[r0]
//        cmp     r1,#0x15
        cmp     r1,#0x3f
        bne     1b
        
        /* Clear interrupt bit */
        ldr     r1,=0xC
        str     r1,[r0]


        /* Setup Stripe IO    */
        /* use UART           */
        ldr     r0,=IOCR_UART
        ldr     r1,=IOCR_UART_VAL
        str     r1,[r0]        

#endif /* EXCALIBUR_PLL_INIT */

        /* 
         * Cache ON 
         * ICache ΤONˤ롥        
         */
        ldr     r0, =CP5_NO1_VAL
        mcr     p15, 0, r0, c1, c0, 0

       /*
        *  Х
        */
        ldr     r0, =AHB12B_CR
        ldr     r1, =AHB12B_CR_VAL
        str     r1, [r0]                


       /*
        *  PLDΥե졼
        *  sbiե뤬󥯤Ƥ(sbi_data_start != 0)
        *  sbiեˤPLD򥳥ե졼󤹤롥
        */
        ldr     r0, =sbi_data_start
        cmp     r0, #0x00
        beq     init_done

        /* 
         * ե졼󥯥å
         */
        ldr     r0,=CONFIG_CLOCK
        ldr     r1,=CONFIG_CLOCK_DATA
        str     r1,[r0]

        /*
         * åƤ뤫å
         */
check_pld_lock:
        ldr     r0,=CONFIG_CONTROL
        ldr     r1,[r0]
        and     r2,r1, #0x01    /* åӥå(ӥå0)ΩäƤ뤫 */
        cmp     r2, #0x01       /* å                            */
        bne     1f
        ldr     r0,=CONFIG_UNLOCK       /* å */
        ldr     r1,=CONFIG_UNLOCK_MAGIC
        str     r1,[r0]
        b       check_pld_lock          /* ⤦٥å */

1:
        ldr     r0,=CONFIG_CONTROL
        ldr     r1,[r0]
        orr     r2, r1, #CONFIG_CONTROL_CO     /* COӥåȤ򥻥å */
        str     r2, [r0]

        /*
         *   IDCODE Υå
         */
        ldr     r0, =sbi_data_start
        ldr     r1, =IDCODE
        ldr     r2, [r1]                /* load IDCODE from chip */
        ldr     r3, [r0, #4]            /* load IDCODE from sbi  */
        cmp     r3, r2
        bne     sbi_error

        ldmia   r0, {r1-r4}              /* load first 4 word     */
        add     r3, r3, r0               /* եåȤ­      */
        add     r0, r3, r4               /* λɥ쥹  */
        
        ldr     r2, =CONFIG_DATA
        ldr     r4, =CONFIG_CONTROL


pld_busy_loop:
        /*
         *  Х򤷤ʤӥ롼
         */
/*
        mov     r1, #PLD_LOOP
pld_loop:
        subs    r1, r1, #1
        bpl     pld_loop        
*/
        ldr     r6, [r4]
        and     r7, r6, #CONFIG_CONTROL_BB
        cmp     r7, #CONFIG_CONTROL_BB
        beq     pld_busy_loop

pld_config_loop:
        ldr     r1, [r3], #0x04
        str     r1, [r2]
    
        cmp     r3,r0
        bne     pld_busy_loop


pld_wait_co_clear:
        ldr     r8, [r4]
        and     r6, r8, #CONFIG_CONTROL_CO
        cmp     r6, #CONFIG_CONTROL_CO
        beq     pld_wait_co_clear

        /*
         * 顼ӥåȤΥå
         */
        and     r7, r8, #CONFIG_CONTROL_E
        cmp     r7, #CONFIG_CONTROL_E
        beq     pld_error
        b       init_done

sbi_error:
        
pld_error:
        b sbi_error

init_done:
        mov     pc, lr



 


/*
 *
 *  ߤν
 *         
 */        
        .text
        .align 4    
        .global IRQ_Handler
IRQ_Handler:

        /* 
         * ߥ⡼ 
         * 
         * cpsrspsr_irq褬r14_irq(lp)ꡤ
         * spsr_irqr14_irqr13(sp)_irq r14,r13Ȥʤ롥
         */

        /* 
         *  ư⡼(ѡХ⡼)
         */
		mov   sp,#(CPSR_SVC | CPSR_FIQ_BIT | CPSR_IRQ_BIT) 
        msr   cpsr_all, sp
        stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */


  
        /*
         * spsrϤ뤿IRQ⡼ɤ
         */
		mov   r0,#(CPSR_IRQ | CPSR_FIQ_BIT | CPSR_IRQ_BIT)
        msr   cpsr,r0
        sub   r0,lr,#4
        mrs   r1,spsr
   
        /*
         *  ѡХ⡼ɤ
         */
        msr   cpsr_all, sp
        str   r0, [sp,#0x18] /* Store pc */
        stmfd sp!,{r1}       /* spsr */


        /*
         *  ¿ųߤȽ
         */
        ldr     r2, =interrupt_count
        ldr     r3, [r2]
        add     r0,r3,#1
        str     r0, [r2]
        cmp     r3, #0x00

        moveq   r2,sp            /* ͥȳߤǤʤ */
        ldreq   sp,=STACKTOP     /* åѹ    */
        stmeqfd sp!,{r2}         /* å¸ */


        /*
         *  װȽꡥ
         *  INT_IDɤ߹ߡ(ˤɬפϤʤ)
         */
        ldr     r0,  =INT_ID
        ldr     r1,  [r0]

        mov     r2,  r1,lsl #2        /* ơ֥ΥեåȤ    */
        ldr     r3,  =int_mask_table  /* ߥޥơ֥θƤӽФ*/
        ldr     r1,  [r3,r2]          /* r0<-ߥޥ              */    
        ldr     r0,  =INT_MASK_CLEAR  /* ߥ쥸ؤΥå      */
        str     r1,  [r0]               
        stmfd   sp!, {r1}             /* ޥӥåȤ¸(ɬפ)  */
        ldr     r3,  =int_table       /* ߵơ֥ɤ߽Ф  */
        ldr     r0,  [r3,r2]

        /*
         *  ̤γߤå
         */
        cmp     r0, #0x00
        beq     undefined_interrupt
        
        /* 
         * ߵ 
         */                
        mov     r2,#(CPSR_SVC|CPSR_FIQ_BIT)
        msr     cpsr,r2

        /* 
         * Call Handler  
         */        
        mov     lr,  pc   
        mov     pc,  r0

        /* 
         * ߶ػ 
         */
        mov     r2,#(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT) 
        msr     cpsr,r2

        ldmfd   sp!, {r0}                 /* ڥǥ󥰥ӥåȤ */
        ldr     r2,  =INT_MASK_SET        /* ߵ             */
        str     r0,  [r2]                

        /* 
         * ߥͥȲ(interrupt_count) ǥ 
         */
        ldr     r2, =interrupt_count
        ldr     r1, [r2]        
        sub     r3, r1, #1                        
        str     r3, [r2]
        cmp     r3, #0x00        
        bne     return_to_task_irq
        
        /* 
         * å 
         */
        ldmfd   sp!,{r0}         
        mov     sp, r0        
                
        ldr     r1, =reqflg    /* Check reqflg */
        ldr     r0, [r1]
        cmp     r0, #0
        beq     return_to_task_irq
        mov     r0, #0
        str     r0, [r1]       /* Clear reqflg */
        b       ret_int

return_to_task_irq:
        /*
         *  
         *  ߵĤȤʤ뤬ƥȾ¸Ƥ뤿ᡤ
         *  Ϥʤ
         */
        ldmfd   sp!,{r1}           /* CPSR */
        msr     spsr, r1           /* ߵ   */
        ldmfd   sp!,{r0-r3,ip,lr,pc}^ /* + ߵ */

        /*
         *  ̤γߤäȤ˸ƤӽФ
         */    
undefined_interrupt:
         b      undef_interrupt
    

