/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: hw_serial.c,v 1.5 2003/12/11 07:00:10 honda Exp $
 */

/*
 *  åȰ¸ꥢI/O⥸塼H8ѡ
 *    ݡȤ 1ܤξ HWPORT1_ADDR˻ꤵ줿ݡȤѤ
 *      2ܤξϡHWPORT1_ADDR桼ѡHWPORT2_ADDR򥳥󥽡
 *      ϤȤƻѤ롣
 *      HWPORTx_ADDR åȰ¸ sys_config.hǻꤹ롣
 *    Υ⥸塼ˤäơXON/XOFFե椬Ԥ
 *      ƤΤǡTxDRxD2ܤǤ褤
 */

#include "jsp_kernel.h"
#include <hw_serial.h>

/*
 *  ꥢݡȤν֥å
 */

const SIOPINIB siopinib_table[TNUM_PORT] = {

#if TNUM_PORT == 1

	{
		SYSTEM_SCI,
		SYSTEM_BAUD_RATE,
		SYSTEM_SCI_SMR,
		},

#elif TNUM_PORT == 2	/* of #if TNUM_PORT == 1 */

	{
		USER_SCI,
		USER_BAUD_RATE,
		USER_SCI_SMR,
		},
	{
		SYSTEM_SCI,
		SYSTEM_BAUD_RATE,
		SYSTEM_SCI_SMR,
		},

#endif	/* of #if TNUM_PORT == 1 */

	};


/*
 *  ꥢݡȤ֥å
 */

SIOPCB siopcb_table[TNUM_PORT];

/*
 *  SIO ID ֥åؤѴޥ
 */

#define get_siopinib(sioid)	(&(siopinib_table[INDEX_SIO(sioid)]))

/*
 *  SCI ν
 */

void
SCI_initialize (ID sioid)
{
	const SIOPINIB	*inib;
	int		i;

	inib = get_siopinib(sioid);

	SCI_cls_por(inib->base);

	outb(inib->base + H8SMR, inib->smr_init);

					/*  ܡ졼  	*/
	outb(inib->base + H8BRR, H8BRR_RATE(inib->baudrate));

			/* ߶ػߤȥå	*/
	outb(inib->base + H8SCR,
	 inb(inib->base + H8SCR) & ~(H8SCR_TIE  | H8SCR_RIE  |
	                             H8SCR_MPIE | H8SCR_TEIE |
	                             H8SCR_CKE1 | H8SCR_CKE0 ));

	/* ܡ졼Ȥ塢1ӥåʬԤʤФʤʤ*/
	for(i = SCI_SETUP_COUNT(inib->baudrate); i -- > 0; )
		;

					/* 顼ե饰򥯥ꥢ		*/
	outb(inib->base + H8SSR,
	 inb(inib->base + H8SSR) & ~(H8SSR_ORER | H8SSR_FER | H8SSR_PER));

	/* ߤߤεĤϥꥢ I/O ǹԤ */
	/*  */

	outb(inib->base + H8SCR,
	 inb(inib->base + H8SCR) | (H8SCR_TE | H8SCR_RE));
	}

/*
 *  SCI Υ
 */

void
SCI_cls_por (UW base)
{
	int i;

	/* TDRE  1 ˤʤޤԤ */
	while ((inb(base + H8SSR) & H8SSR_TDRE) == 0)
		;

	/* 11ӥåʬԤġ*/
	for(i = SCI_SETUP_COUNT(H8_MIN_BAUD_RATE) * 11; i -- > 0; )
		;
					/* 		*/
	outb(base + H8SCR,
	 inb(base + H8SCR) & ~(H8SCR_TIE | H8SCR_RIE | H8SCR_TE | H8SCR_RE));
	}

/*
 *  SCI_in_handler -- SCI ϳߥϥɥ
 */

void
SCI_in_handler(ID sioid)
{
	SIOPCB	*pcb;
	UB	status;

	pcb = get_siopcb(sioid);
	status = inb(pcb->inib->base + H8SSR);
	
	if (status & (H8SSR_ORER | H8SSR_FER | H8SSR_PER)) {

		/* 顼		*/

	    	/* 顼ե饰򥯥ꥢ	*/
		outb(pcb->inib->base + H8SSR, status & ~(H8SSR_ORER | H8SSR_FER | H8SSR_PER));
		}

	if (status & H8SSR_RDRF) {
		if (pcb->openflag)
			/* ǽХå롼ƽФ*/
			SCI_ierdy_rcv(pcb->exinf);
		else
			outb(pcb->inib->base + H8SSR, status & ~H8SSR_RDRF);
		}
	}

/*
 *  SCI_out_handler -- SCI ϳߥϥɥ
 */

void
SCI_out_handler(ID sioid)
{
	SIOPCB	*pcb;

	pcb = get_siopcb(sioid);
	if (pcb->openflag) {
		/* ǽХå롼ƽФ*/
		SCI_ierdy_snd(pcb->exinf);
		}
	}

#ifdef H8_CFG_SCI_ERR_HANDLER

/*
 *  SCI_err_handler -- SCI 顼ϳߥϥɥ
 */

void
SCI_err_handler(ID sioid)
{
	SIOPCB	*pcb;
	UB	status;

	pcb = get_siopcb(sioid);
	status = inb(pcb->inib->base + H8SSR);
	if (status & (H8SSR_ORER | H8SSR_FER | H8SSR_PER)) {

		/* 顼		*/

	    	/* 顼ե饰򥯥ꥢ	*/
		outb(pcb->inib->base + H8SSR, status & ~(H8SSR_ORER | H8SSR_FER | H8SSR_PER));
		}
	}

#endif	/* of #ifdef H8_CFG_SCI_ERR_HANDLER */

/*
 *  sio_initialize -- ꥢݡȥɥ饤Фν
 */

void
sio_initialize (void)
{
	int ix;

	/* SIO ֥åν */
	for (ix = TNUM_PORT; ix -- > 0; ) {
		siopcb_table[ix].inib     = &siopinib_table[ix];
		siopcb_table[ix].openflag = FALSE;
		}
	}

/*
 *  sio_ena_cbr -- ꥢ I/O ΥХåε
 */

void
sio_ena_cbr(SIOPCB *pcb, UINT cbrtn)
{
	switch (cbrtn) {
	case SIO_ERDY_SND:
		SCI_enable_send(pcb);
		break;
	case SIO_ERDY_RCV:
		SCI_enable_recv(pcb);
		break;
		}
	}

/*
 *  sio_dis_cbr -- ꥢ I/O ΥХåζػ
 */

void
sio_dis_cbr(SIOPCB *pcb, UINT cbrtn)
{
	switch (cbrtn) {
	case SIO_ERDY_SND:
		SCI_disable_send(pcb);
		break;
	case SIO_ERDY_RCV:
		SCI_disable_recv(pcb);
		break;
		}
	}

/*
 *  SCI 
 */

void
sio_in_handler (void)
{
	SCI_in_handler(1);
	}

void
sio_out_handler (void)
{
	SCI_out_handler(1);
	}

#ifdef H8_CFG_SCI_ERR_HANDLER

void
sio_err_handler (void)
{
	SCI_err_handler(1);
	}

#endif	/* of #ifdef H8_CFG_SCI_ERR_HANDLER */

#if TNUM_PORT >= 2

void
sio_in2_handler (void)
{
	SCI_in_handler(2);
	}

void
sio_out2_handler (void)
{
	SCI_out_handler(2);
	}

#ifdef H8_CFG_SCI_ERR_HANDLER

void
sio_err2_handler (void)
{
	SCI_err_handler(2);
	}

#endif	/* of #ifdef H8_CFG_SCI_ERR_HANDLER */

#endif	/* of #if TNUM_PORT >= 2 */
