/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 */

#ifndef _VR4131_H_
#define _VR4131_H_

/* CP0ϥɤΤλֲԤ NOP_FOR_CP0_HAZARD  */
/* VR4131Ǥmtc0̿ľ夫߶ػߤˤʤäƤΤnop̿ʤƤ
    */
#define NOP_FOR_CP0_HAZARD

/* Config쥸  */
#define BP		BIT16	/* ʬͽ¬ */

/* TLB Υȥκ  */
#define TMAX_TLB	31

/* TLBޥ */
#define TLB_VPN2	0x800

/* å̿ */
#define Index_Invalidate_I	0x0+0x0
#define Index_Store_Tag_I       0x8+0x0
#define Index_Store_Tag_D       0x8+0x1

/* åΥ饤󥵥(Хñ)  */
#define D_CACHE_LINE_SIZE 	0x10	/* 16Х */
#define I_CACHE_LINE_SIZE 	0x10	/* 16Х */

/*============================================================================*/

/*
 *  GDB STUB / PARTNER-Jƥॳ / ľܸƽФ 󥽡ƽФ롼
 *  (GDB_STUB, PARTNER-J ϥƥȤƤޤ)
 */

/*
 *  gdb stub ˤ륳󥽡
 */
/* a0($4) = 0xfe00, a1($5) = Ϥ饯 ơ
   SYSCALL 㳰ȯ롣 */
#ifndef _MACRO_ONLY

/* δؿƤӽФˤϡơ쥸EXLӥå = 0 ǸƤӽФȡ
   ʤߡͥǤϡХʡɽꥢϻ˸ƽФԤäƤ롣*/
Inline void stub_putc(int c) {

	Asm("	move	$5, %0;		\
	     	li	$4, 0xfe00;	\
		syscall;		\
		nop"
		:: "r"(c)
		: "$4","$5" );
}

#endif /* _MACRO_ONLY */

#ifdef GDB_STUB
#define vr4131_putc(c) stub_putc(c)
#else  /* GDB_STUB */
#define	vr4131_putc(c) vr4131_dsiu_write_por( (VP) DSIUTH, (UB) c )
#endif /* GDB_STUB */

/*
 *  PARTNER-J Υƥॳˤ륳󥽡ϡʥƥȤƤޤ󡣡
 */
#ifndef _MACRO_ONLY

Inline void partner_putc(int c) {

	Asm("	move	$2, %0;		\
		li	$1, 0xfe00;	\
		jal	SYSCALL;	\
		nop"
		:: "r"(c)
		: "$1","$2" );
}

#endif /* _MACRO_ONLY */

#ifdef PARTNER_J	/* PARTNER_J ξ *
#define vr4131_putc(c) partner_putc(c)
#else  /* GDB_STUB */
#define	vr4131_putc(c) vr4131_dsiu_write_por( (VP) DSIUTH, (UB) c )
#endif /* GDB_STUB */

#ifndef _MACRO_ONLY
Inline void
vr4131_exit() {
	/* GDB_STUB ѻˤϡSTUBƬֽɬפ⡣ */
}
#endif /* _MACRO_ONLY */


/*============================================================================*/
/* ʲϡƥ˥åȤȤˡvr4131_xxx.hȤƤޤȤ뤳Ȥɬפ⡣ */

/*
 * åޥ˥å(CMU)ط
 */
#define CMUCLKMSK	(BASE_ADDR + 0x0f000060)

#define MSKSIU		BIT1	/* SIU, DSIUؤTClock */
#define MSKSSIU		BIT8	/* SIUؤ18.432MHzå */
#define MSKDSIU		BIT11	/* DSIUؤ18.432MHzå */

/*
 * ѥޥ͡ȥ˥å(PMU)ط
 */
#define PMUINTREG	(BASE_ADDR + 0x0f0000c0)	/* PMU ߡơ쥸 */
#define PMUCNTREG	(BASE_ADDR + 0x0f0000c2)	/* PMU ȥ쥸 */
#define PMUTCLKDIVREG	(BASE_ADDR + 0x0f0000cc)

/* for PMUINTREG */
#define TIMOUTRST	BIT5		/* HALTimerꥻåȸ */
/* for PMUCNTREG */
#define HALTIMERRST	BIT2		/* HALTimerꥻå*/
/* for PMUTCLKDIVREG */
#define VTDIV_3		BIT1 | BIT0

/*
 * Хȥ˥å(BCU)ط
 */
#define BCUCNTREG1	(BASE_ADDR + 0x0f000000)
#define ROMSIZEREG	(BASE_ADDR + 0x0f000004)
#define ROMSPEEDREG	(BASE_ADDR + 0x0f000006)
#define IO0SPEEDREG	(BASE_ADDR + 0x0f000008)
#define IO1SPEEDREG	(BASE_ADDR + 0x0f00000a)
#define BCUCNTREG3	(BASE_ADDR + 0x0f000016)

/* for ROMSIZEREG */
#define SIZE3_4		BIT12
#define SIZE2_4		BIT8
#define SIZE1_4		BIT4
#define SIZE0_4		BIT0
/* for ROMSPEEDREG */
#define ROM4_WAIT_5VTClock	BIT13 | BIT12
#define ROM2_WAIT_8VTClock	BIT2 | BIT0
/* for IO0SPEEDREG */
#define IO0_1_WAIT_4	BIT1 | BIT0
/* for IO1SPEEDREG */
#define IO1_3_WAIT_11	BIT11
/* for BCUCNTREG3 */
#define EXT_ROMCS_3ROM_2ROM	BIT13 | BIT12
#define IO32			BIT7
#define LCDSEL1_BUFFER		BIT1
#define LCDSEL0_BUFFER		BIT0

/*
 * SDRAMȥ˥å(SDRAMU)ط
 */
#define SDRAMMODEREG	(BASE_ADDR + 0x0f000400)
#define SDRAMCNTREG	(BASE_ADDR + 0x0f000402)
#define BCURFCNTREG	(BASE_ADDR + 0x0f000404)
#define BCURFCOUNTREG	(BASE_ADDR + 0x0f000406)
#define RAMSIZEREG	(BASE_ADDR + 0x0f000408)

/* for SDRAMMODEREG */
#define SCLK		BIT15
#define LTMODE_2	BIT5
/* for SDRAMCNTREG */
#define TRC_3VTClock	BIT9 | BIT8
#define TDAL_2VTClock	BIT5
#define TRCD_2VTClock	BIT1
/* for RAMSIZEREG */
#define SIZE3_64	BIT14 | BIT12
#define SIZE2_64	BIT10 | BIT8
#define SIZE1_64	BIT6 | BIT4
#define SIZE0_64	BIT2 | BIT0

/*
 * ꥢ륤󥿥ե˥å(SIU)ط
 */
#define SIURESET	(BASE_ADDR + 0x0f000809)

/* for RESET */
#define DSIURESET	BIT1	/*  DSIUꥻåȤե饰  */

#endif /* _VR4131_H_ */
