/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 */

#ifndef _VR4131_DSIU_H_
#define _VR4131_DSIU_H_

#include <t_config.h>

/*
 *  VR4131¢ǥХåꥢ륤󥿥ե˥å(DSIU)Ϣ
 *  (ʰNS16550)
 */

/* DSIU쥸Υɥ쥹 */
#define DSIURB		(BASE_ADDR + 0x0f000820)	/* Хåե쥸(꡼ɻ) */
#define DSIUTH		(BASE_ADDR + 0x0f000820)	/* ݻ쥸(饤Ȼ) */
#define DSIUDLL		(BASE_ADDR + 0x0f000820)	/* ʬ沼̥쥸 */
#define DSIUIE		(BASE_ADDR + 0x0f000821)	/* ߵĥ쥸 */
#define DSIUDLM		(BASE_ADDR + 0x0f000821)	/* ʬ̥쥸 */
#define DSIUIID		(BASE_ADDR + 0x0f000822)	/* ɽ쥸(꡼ɻ) */
#define DSIUFC		(BASE_ADDR + 0x0f000822)	/* FIFO 쥸(饤Ȼ) */
#define DSIULC		(BASE_ADDR + 0x0f000823)	/* 饤쥸 */
#define DSIUMC		(BASE_ADDR + 0x0f000824)	/* ǥ쥸 */
#define DSIULS		(BASE_ADDR + 0x0f000825)	/* 饤֥쥸 */
#define DSIUMS		(BASE_ADDR + 0x0f000826)	/* ǥ֥쥸 */
#define DSIUSC		(BASE_ADDR + 0x0f000827)	/* å쥸 */

/* for DSIULC */
#define	WORD_LENGTH_8		BIT1 | BIT0
#define	STOP_BITS_1		0		/* BIT2 */
#define	PARITY_NON		0		/* BIT3, 4 */
/* BIT5,6 ά */
#define	DIVISOR_LATCH_ACC	BIT7

/* for DSIUIE */
#define	DIS_INT			0
#define	RECEIVE_DATA_AVAILABLE	BIT0
#define	TRANS_REG_EMPTY		BIT1
#define RECEIVE_LINE_STATUS	BIT2
#define MODEM_STATUS		BIT3

/* for DSIUMC */
#define	DTR			BIT0
#define	RTS			BIT1

/* for DSIUFC */
#define	FIFO_ENABLE		BIT0
#define	RECEIVE_FIFO_RESET	BIT1
#define	TRANS_FIFO_RESET	BIT2
#define RECEIVE_TRIG_1_BYTE	0	/* BIT6, 7 */
#define RECEIVE_TRIG_4_BYTE	BIT6
#define	RECEIVE_TRIG_8_BYTE	BIT7
#define	RECEIVE_TRIG_14_BYTE	BIT6 | BIT7

/* for DSIUIID */
#define	INT_MASK		0x0e
#define	INT_RECEIVE_DATA	BIT2
#define INT_CHAR_TIME_OUT	BIT3 | BIT2
#define	INT_TRANS_EMPTY		BIT1

/* ܡ졼ط */
#define	DIVISOR			XIN_CLOCK / (16 * DEVIDE_RATIO)

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_control_block	SIOPCB;

/*
 *  Хå롼μֹ
 */
#define SIO_ERDY_SND	1u		/* ǽХå */
#define SIO_ERDY_RCV	2u		/* ΥХå */

/*
 *  SIOɥ饤Фν롼
 */
extern void	vr4131_dsiu_initialize(void);

/*
 *  ץ󤷤ƤݡȤ뤫
 */
extern BOOL	vr4131_dsiu_openflag(void);

/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB	*vr4131_dsiu_opn_por(ID siopid, VP_INT exinf);

/*
 *  ꥢI/OݡȤΥ
 */
extern void	vr4131_dsiu_cls_por(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤؤʸ
 */
extern BOOL	vr4131_dsiu_snd_chr(SIOPCB *siopcb, char c);

/*
 *  ꥢI/OݡȤʸ
 */
extern INT	vr4131_dsiu_rcv_chr(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
extern void	vr4131_dsiu_ena_cbr(SIOPCB *siopcb, UINT cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void	vr4131_dsiu_dis_cbr(SIOPCB *siopcb, UINT cbrtn);

/*
 *  SIOγߥӥ롼
 */
extern void	vr4131_dsiu_dsiu_isr(void);

/*
 *  ꥢI/OݡȤǽХå
 */
extern void	vr4131_dsiu_ierdy_snd(VP_INT exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
extern void	vr4131_dsiu_ierdy_rcv(VP_INT exinf);

/*============================================================================*/
/* ʲϡvr4131_dsiu_sil.hȤե٤Ȼפ */

/*
 *  ǥХ쥸Υֳֻ֡nsecñ̡
 */
#define	VR4131_DSIU_DELAY	100u		/* ͤ˺Ϥʤ */

/*
 *  ǥХ쥸Υֳֻ֡ʥݡ󥰽ϸnsecñ̡
 *
 *  㡧ưΥХʡ
 *  ͤϡkseg1(åͭ)ǤưˡʸȤʤ٤
 *  kseg0(å̵)Ǥưϡ
 *      VR4131_DSIU_DELAY_POR = 1000000u ٤ꤹȡ礦ɤ
 */
#define	VR4131_DSIU_DELAY_POR	100000000u

/*
 *  ǥХ쥸ؤΥؿ
 */
Inline UB vr4131_dsiu_read_reg( VP reg ) {

	UB	val;

	/* ǡregϰϥåФ줷ʡ */
	val = sil_reb_mem( reg );
	sil_dly_nse( VR4131_DSIU_DELAY );

	return( val );
}

Inline void vr4131_dsiu_write_reg( VP reg, UB val) {

	/* ǡregϰϥåФ줷ʡ */
	sil_wrb_mem( reg, (VB) (val & 0x000000ff) );
	sil_dly_nse( VR4131_DSIU_DELAY );
}

/* ݡ󥰽 sys_putc(c)  */
Inline void vr4131_dsiu_write_por( VP reg, UB val) {

	/* ǡregϰϥåФ줷ʡ */
	sil_wrb_mem( reg, (VB) (val & 0x000000ff) );
	sil_dly_nse( VR4131_DSIU_DELAY_POR );
}

/*============================================================================*/
/* sys_config.c(ݡ󥰽ϻѤκ¤)ꥢ륳ȥν */
#define scc_init							\
	vr4131_dsiu_write_reg( (VP) DSIUIE,  DIS_INT );			\
	vr4131_dsiu_write_reg( (VP) DSIULC,  WORD_LENGTH_8 | STOP_BITS_1 | PARITY_NON | DIVISOR_LATCH_ACC ); \
	vr4131_dsiu_write_reg( (VP) DSIUDLL, LO8(DIVISOR) );		\
	vr4131_dsiu_write_reg( (VP) DSIUDLM, HI8(DIVISOR) );		\
	vr4131_dsiu_write_reg( (VP) DSIULC,  WORD_LENGTH_8 | STOP_BITS_1 | PARITY_NON ); \
	vr4131_dsiu_write_reg( (VP) DSIUIE,  RECEIVE_DATA_AVAILABLE)

#endif /* _VR4131_DSIU_H_ */
