/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 */

#ifndef _VR5500_H_ 
#define _VR5500_H_ 

/* CP0ϥɤΤλֲԤ NOP_FOR_CP0_HAZARD  */
/* VR5500ǤCP0ϥɤMIPS3ȽǤƤ뤿Ԥ
   ɬפʤ*/
#define NOP_FOR_CP0_HAZARD

/* TLB Υȥκ  */
#define TMAX_TLB	47

/* TLB VPN2 */
#define TLB_VPN2	0x2000

/* å̿ */
#define Index_Store_Tag_I       0x8+0x0
#define Index_Store_Tag_D       0x8+0x1

/* åΥ饤󥵥(Хñ)  */
#define D_CACHE_LINE_SIZE 0x20	/*  */
#define I_CACHE_LINE_SIZE 0x20	/*  */

/*============================================================================*/

/*
 *  GDB STUB / PARTNER-Jƥॳ / ľܸƽФ 󥽡ƽФ롼
 *  (PARTNER-J ϥƥȤƤޤ)
 */

/*
 *  gdb stub ˤ륳󥽡
 */
/* a0($4) = 0xfe00, a1($5) = Ϥ饯 ơ
   SYSCALL 㳰ȯ롣 */
#ifndef _MACRO_ONLY

/* δؿƤӽФˤϡơ쥸EXLӥå = 0 ǸƤӽФȡ
   ʤߡͥǤϡХʡɽꥢϻ˸ƽФԤäƤ롣*/
Inline void stub_putc(int c) {

	Asm("	move	$5, %0;		\
	     	li	$4, 0xfe00;	\
		syscall;		\
		nop"
		:: "r"(c)
		: "$4","$5" );
}

#endif /* _MACRO_ONLY */

#ifdef GDB_STUB
#define vr5500_putc(c) stub_putc(c)
#else  /* GDB_STUB */
#define	vr5500_putc(c) tl16pir552_write_por( (VP) UART_CH01, THR, (UB) c )
#endif /* GDB_STUB */

/*
 *  PARTNER-J Υƥॳˤ륳󥽡ϡʥƥȤƤޤ󡣡
 */
#ifndef _MACRO_ONLY

Inline void partner_putc(int c) {

	Asm("	move	$2, %0;		\
		li	$1, 0xfe00;	\
		jal	SYSCALL;	\
		nop"
		:: "r"(c)
		: "$1","$2" );
}

#endif /* _MACRO_ONLY */

#ifdef PARTNER_J	/* PARTNER_J ξ *
#define vr5500_putc(c) partner_putc(c)
#else  /* GDB_STUB */
#define	vr5500_putc(c) tl16pir552_write_por( (VP) UART_CH01, THR, (UB) c )
#endif /* GDB_STUB */

#ifndef _MACRO_ONLY
Inline void
vr5500_exit() {
}
#endif /* _MACRO_ONLY */

#endif /* _VR5500_H_  */
