/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: kz_sh1.h,v 1.7 2003/12/18 06:34:40 honda Exp $
 */

/*
 *  ԥޥԥ塼	KZ-SH1-01
 *  CQ RISCɾå	SH-1
 *  Υϡɥ񸻤
 */

#ifndef _KZ_SH1_H_
#define _KZ_SH1_H_

/*
 *  GDB STUBƽФ롼̤
 */
#ifndef _MACRO_ONLY
#ifdef GDB_STUB

#define kz_sh1_exit	stub_exit
#define kz_sh1_putc	stub_putc

Inline void
stub_exit(void)
{
}

Inline void
stub_putc(char c)
{
}

/*
 *  CQ RISCɾåȤΥ˥ƽФ롼̤
 */
#elif defined(CQ_SH1_DEB) 	/* GDB_STUB */

#define kz_sh1_exit	monitor_exit
#define kz_sh1_putc(c)	monitor_putc(c)

Inline void
monitor_exit()
{
	while(1);
}

int monitor_putc(int c);



/*
 *  GDB stub˥ȤʤROMѡ
 */
#else /* GDB_STUBCQ_SH1_DEB*/

Inline void
kz_sh1_exit()
{
	while(1);
}

extern void	sh1sci_putc_pol(char c);	/*  sh1sci.c  */

Inline void 
kz_sh1_putc(char c)
{
	sh1sci_putc_pol(c);
}

#endif /* GDB_STUBCQ_SH1_DEB */
#endif /* _MACRO_ONLY */
#endif /* _KZ_SH1_H_ */
